import { Behavior } from "./Behavior";
import { Particle } from "../Particle";
import { Vector3 } from "three";
import SimplexNoise from "../util/simplex-noise";
export declare class Noise implements Behavior {
    frequency: Vector3;
    power: Vector3;
    type: string;
    generator: SimplexNoise;
    duration: number;
    temp: Vector3;
    constructor(frequency: Vector3, power: Vector3);
    initialize(particle: Particle): void;
    update(particle: Particle, delta: number): void;
    toJSON(): any;
    frameUpdate(delta: number): void;
    static fromJSON(json: any): Behavior;
    clone(): Behavior;
    reset(): void;
}
