import { RotationGenerator } from "./RotationGenerator";
import { Quaternion } from "three";
import { FunctionValueGenerator, ValueGenerator } from "./ValueGenerator";
import { FunctionJSON } from "./FunctionJSON";
export declare class EulerGenerator implements RotationGenerator {
    angleX: FunctionValueGenerator | ValueGenerator;
    angleY: FunctionValueGenerator | ValueGenerator;
    angleZ: FunctionValueGenerator | ValueGenerator;
    type: "rotation";
    constructor(angleX: FunctionValueGenerator | ValueGenerator, angleY: FunctionValueGenerator | ValueGenerator, angleZ: FunctionValueGenerator | ValueGenerator);
    genValue(quat: Quaternion, t?: number): Quaternion;
    toJSON(): FunctionJSON;
    static fromJSON(json: FunctionJSON): EulerGenerator;
    clone(): RotationGenerator;
}
