import { Vector2 } from "three";
import { ExecutionContext, NodeType } from "./NodeType";
export declare class Node {
    id: string;
    inputs: (Wire | ConstInput | undefined)[];
    outputs: (Wire | undefined)[];
    type: NodeType;
    data: {
        [key: string]: any;
    };
    position: Vector2;
    outputValues: any[];
    constructor(type: NodeType);
}
export interface ConstInput {
    getValue(context: ExecutionContext): any;
}
export declare class Wire {
    input: Node;
    inputIndex: number;
    output: Node;
    outputIndex: number;
    constructor(input: Node, inputIndex: number, output: Node, outputIndex: number);
}
