import { NodeValueType } from "./NodeValueType";
import { NodeGraph } from "./NodeGraph";
import { Particle } from "../Particle";
export interface ExecutionContext {
    inputs: any[];
    outputs: any[];
    particle?: Particle;
    delta?: number;
}
type NodeExecFunction = (context: ExecutionContext, inputs: any[], outputs: any[]) => void;
export declare class NodeType {
    name: string;
    inputTypes: NodeValueType[];
    outputTypes: NodeValueType[];
    func: NodeExecFunction;
    constructor(name: string, func: NodeExecFunction, inputTypes: NodeValueType[], outputTypes: NodeValueType[]);
}
export declare class GraphNodeType extends NodeType {
    nodeGraph: NodeGraph;
    constructor(nodeGraph: NodeGraph);
}
export {};
