export declare class LinkedListNode<T> {
    data: T;
    next: LinkedListNode<T> | null;
    prev: LinkedListNode<T> | null;
    constructor(data: T);
    hasPrev(): boolean;
    hasNext(): boolean;
}
export declare class CircularLinkedList<T> {
    length: number;
    head: LinkedListNode<T> | null;
    constructor();
    isEmpty(): boolean;
    start(): T | null;
    push(data: T): LinkedListNode<T>;
    insertAfter(prevNode: LinkedListNode<T>, data: T): LinkedListNode<T>;
    last(): LinkedListNode<T> | undefined;
    /**
     * Returns an iterator over the values
     */
    values(): Generator<T, void, unknown>;
}
export declare class LinkedList<T> {
    length: number;
    head: LinkedListNode<T> | null;
    tail: LinkedListNode<T> | null;
    constructor();
    isEmpty(): boolean;
    clear(): void;
    front(): T | null;
    back(): T | null;
    /**
     * remove at head in O(1)
     */
    dequeue(): T | undefined;
    /**
     * remove at tail in O(1)
     */
    pop(): T | undefined;
    /**
     * add at head in O(1)
     */
    queue(data: T): void;
    /**
     * add at tail in O(1)
     */
    push(data: T): void;
    insertBefore(node: LinkedListNode<T>, data: T): void;
    remove(data: T): void;
    /**
     * Returns an iterator over the values
     */
    values(): Generator<T, void, unknown>;
}
